%bcond_with offensive
%bcond_with tests

%global CookieDir %{_datadir}/games/fortune

%undefine __cmake_in_source_build

Name:		fortune-mod
Version:	3.20.0
Release:    1%{?dist}
Summary:	A program which will display a fortune

License:	BSD
URL:		https://github.com/shlomif/fortune-mod
Source0:	https://www.shlomifish.org/open-source/projects/fortune-mod/arcs/fortune-mod-%{version}.tar.xz
Source1:	kernelnewbies-fortunes.tar.gz
Source2:	bofh-excuses.tar.bz2
Source3:	fortune-tao.tar.gz
Source4:	http://www.splitbrain.org/Fortunes/hitchhiker/fortune-hitchhiker.tgz
Source5:	osfortune.tar.gz
Source6:	http://humorix.org/downloads/humorixfortunes-1.4.tar.gz

BuildRequires:	perl(Cwd)
BuildRequires:	perl(File::Find::Object)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(FindBin)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(IO::All)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Path::Tiny)
BuildRequires:	perl(Test::Differences)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Trap)
BuildRequires:	perl(autodie)
BuildRequires:	perl(lib)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl-Test-Harness
BuildRequires:	perl-interpreter
BuildRequires:	perl-libs
BuildRequires:	pkgconfig(librinutils)
BuildRequires:	recode-devel
BuildRequires:  cmake
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  chrpath


%description
Fortune-mod contains the ever-popular fortune program, which will
display quotes or witticisms. Fun-loving system administrators can add
fortune to users' .login files, so that the users get their dose of
wisdom each time they log in.


%prep
%setup -q -n %{name}-%{version}

%build
%cmake -DCOOKIEDIR=%{CookieDir} -DLOCALDIR=%{CookieDir} -DNO_OFFENSIVE=TRUE
%cmake_build

%install
%cmake_install

tar zxvf %{SOURCE1} -C %{buildroot}%{CookieDir}
%if %{without offensive}
rm -f %{buildroot}%{CookieDir}/men-women*
%endif

mv %{buildroot}/usr/games/fortune %{buildroot}%{_bindir}
rm -f %{buildroot}%{_bindir}/rot
rm -f %{buildroot}%{CookieDir}/debian*
rm -f %{buildroot}%{CookieDir}/off/debian*

bzcat %{SOURCE2} | tar xvf - -C %{buildroot}%{CookieDir}

tar zxvf %{SOURCE3} -C %{buildroot}%{CookieDir}/ fortune-tao/tao*
mv %{buildroot}%{CookieDir}/fortune-tao/* %{buildroot}%{CookieDir}/
rmdir %{buildroot}%{CookieDir}/fortune-tao

tar zxvf %{SOURCE4} -C %{buildroot}%{CookieDir}/ fortune-hitchhiker/hitch*
mv %{buildroot}%{CookieDir}/fortune-hitchhiker/* %{buildroot}%{CookieDir}/
rmdir %{buildroot}%{CookieDir}/fortune-hitchhiker

tar zxvf %{SOURCE5} -C %{buildroot}%{CookieDir}/
chmod 644 %{buildroot}%{CookieDir}/osfortune*

tar zxvf %{SOURCE6} -C %{buildroot}%{CookieDir}/ humorixfortunes-1.4/*
mv %{buildroot}%{CookieDir}/humorixfortunes-1.4/* %{buildroot}%{CookieDir}/
rmdir %{buildroot}%{CookieDir}/humorixfortunes-1.4

strfile="`find . -type f -name strfile -executable -print | head -1`"
for i in \
    kernelnewbies bofh-excuses tao hitchhiker \
    osfortune humorix-misc humorix-stories \
; do "$strfile" %{buildroot}%{CookieDir}/$i ; done

chrpath -d %{buildroot}%{_bindir}/strfile
chrpath -d %{buildroot}%{_bindir}/unstr
chrpath -d %{buildroot}%{_bindir}/fortune

%check
%__rm -f tests/t/trailing-space*.t
%__rm -f tests/t/valgrind*.t
%ctest


%files
%license COPYING.txt
%doc README ChangeLog TODO
%{_bindir}/fortune
%{_bindir}/strfile
%{_bindir}/unstr
%{CookieDir}
%{_mandir}/man*/*

%changelog
* Mon Jul 01 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.20.0-1
- initial build
